package pr_x.driver.text;

import java.util.Properties;
import java.sql.*;

/**
 * Title:        Text Driver
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      FEL
 * @author JMB
 * @version 1.0
 */


/**   TextDriver is very simple driver allowing  retrieval in
 *   a text file, only.
 */
public class TextDriver implements Driver {
/**   This is static initizer which is performed
 *   just once, when the class is loaded. And it calls
 *   constructor.
 */
  static {
	   try {  System.out.println("sta 1");
	   	   new TextDriver();
	   	   System.out.println("sta 2");
	   }
    	catch (SQLException e) { e.printStackTrace();}
  }
/**   This constructor registers the TextDriver object
 *   in DriverManager by calliing its staic method.
 */
  public TextDriver() throws SQLException {
  	System.out.println("td  "+this);

	   DriverManager.registerDriver(this);
  }
/**   Test acceptable URL
 *  @param  url tested url
 *  @return whether is acceptable
 */
  public boolean acceptsURL(String url) throws SQLException {
  	return url.startsWith("jdbc:text://") && url.endsWith("txt");
  }
/**   Provides connection to specified file
 *   @param  url
 *   @param  info
 *   @return Connection
 */
  public Connection connect(String url, Properties info)throws SQLException {
	  if (!acceptsURL(url)) return null;
	  String filename = url.substring(12);
	  System.out.println("file="+filename+"   props="+info);
	  return new TextConnection(filename);
  }
/**  Provide access to TextDriver properties.
 *
 */
  public DriverPropertyInfo[] getPropertyInfo(String url, Properties info) throws SQLException {
  	 DriverPropertyInfo dpi1=new DriverPropertyInfo("name1","value1");
  	   String[] c1={"c11","c12"};  dpi1.choices=c1;
  	   dpi1.description="descr1";
  	   dpi1.required=true;
  	 DriverPropertyInfo dpi2=new DriverPropertyInfo("name2","value2");

  	 DriverPropertyInfo[] dpi=new DriverPropertyInfo[2];
  	 dpi[0]=dpi1; dpi[1]=dpi2;
  	 return dpi;
  }

/** Identification */
  public int getMajorVersion() { return 1; }
/** Identification */
  public int getMinorVersion() { return 0; }
/** Allways not compliant */
  public boolean jdbcCompliant() { return false; }
/** Standard self identification method */
  public String toString() {
  	 return getClass()+"[version="+getMajorVersion()+"."+getMinorVersion()+
  	                   ",jdbcCompliant="+jdbcCompliant()+"]";

  }
}
