package pr_x;
import java.io.*;
import java.net.*;


/**
 *
 * <p>Title: </p>
 * Multiserver
 * @author JMB
 * @version 1.0
 */
public class X08_ServerDB extends Thread {

    private int port;
    private ServerSocket listen_socket;

    // Create a ServerSocket to listen for connections on;  start the thread.
    public X08_ServerDB(int port) {
        this.port = port;
        try { listen_socket = new ServerSocket(port); }
        catch (IOException e) { System.out.println("Socket failed"); }
        System.out.println("Server ready:"+
            "\n   on address "+  listen_socket.getInetAddress() +
            "\n   listening on port=" + listen_socket.getLocalPort());
        this.start();
    }

    public void run() {
        try {
            while(true) {
                Socket client_socket = listen_socket.accept();
                new Clerk(client_socket);
            }
        } catch (IOException e) { System.out.println("Accept failed");}
    }

    public static void main(String[] args) {
        new X08_ServerDB(6789);
    }
}


class Clerk extends Thread {  // Dedicated clerk deals with one client
    static int ctr=0;
    int id=0;
    private Socket client;
    private ObjectInputStream in;
    private ObjectOutputStream out;


    // Initialize the streams and start the thread
    public Clerk(Socket client_socket) {
        id=++ctr;
        client = client_socket;
        try {
            out = new ObjectOutputStream( client.getOutputStream());
            in =  new ObjectInputStream(  client.getInputStream());
            //System.out.println("Clerk streams  "+out+"  "+in);
        }
        catch (IOException e) {
            try { client.close(); } catch (IOException e2) { ; }
              System.err.println("err. socket streams: " + e);
            return;
        }
        this.start();
    }

    public void run() {  // Provide the service

        System.out.println(">>>  Clerk  "+id+"  started with "+client);
        String line, res;
        try {
            out.writeObject("DB service ready\n");
            out.reset();
            for(;;) {
                line =(String) in.readObject();   // read in a line
                System.out.println(">>>  Clerk  "+id+"  read="+line);
                if (line == null) break;
                res=DB.perform(line);
                System.out.println(">>>  Clerk  "+id+"  res="+res);
                out.writeObject(res);
                out.reset();
            }
        }
        catch (Exception e) { ; }
        finally { try {client.close();} catch (IOException e2) {;} }
    }
}
